/**
 * Copyright (c) 2000-present Liferay, Inc. All rights reserved.
 *
 * The contents of this file are subject to the terms of the Liferay Enterprise
 * Subscription License ("License"). You may not use this file except in
 * compliance with the License. You can obtain a copy of the License by
 * contacting Liferay, Inc. See the License for the specific language governing
 * permissions and limitations under the License, including but not limited to
 * distribution rights of the Software.
 *
 *
 *
 */

package com.liferay.jenkins.results.parser;

import org.json.JSONObject;

/**
 * @author Kenji Heigel
 */
public class TestResultFactory {

	public static TestResult newTestResult(
		Build build, JSONObject caseJSONObject) {

		String className = caseJSONObject.getString("className");

		if (className.contains("com.liferay.poshi.runner.PoshiRunner")) {
			return new PoshiTestResult(build, caseJSONObject);
		}

		return new BaseTestResult(build, caseJSONObject);
	}

}